package com.docus.server.message.config;

import com.docus.core.util.Func;
import com.docus.server.message.enums.DataFormatEnum;
import com.docus.server.message.util.TableJsonRead;
import lombok.Data;

import java.util.List;
import java.util.Objects;

/**
 * @author wyb
 */
public class WsMessageForwardConfig {
    private final static String CONFIG_FILE_PATH = "data-config";
    private final static String CONFIG_FILE_NAME = "ws-message-forward-config.json";

    public static WsMessageForward wsMessageForward(String method) {
        Objects.requireNonNull(method);
        TableJsonRead jsonReader = new TableJsonRead();
        String wsMessageForwardConfigJson = jsonReader.ReadContent(CONFIG_FILE_PATH, CONFIG_FILE_NAME);
        if (wsMessageForwardConfigJson == null) {
            return null;
        }
        List<WsMessageForward> wsMessageForwardList = Func.parseJsonArray(wsMessageForwardConfigJson, WsMessageForward.class);
        if (Func.isEmpty(wsMessageForwardList)) {
            return null;
        }
        for (WsMessageForward wsMessageForward : wsMessageForwardList) {
            if (method.equals(wsMessageForward.getMethod())) {
                return wsMessageForward;
            }
        }
        return null;
    }

    @Data
    public static class WsMessageForward {
        private String method;
        private List<String> urls;
        private String errorResult;
        /**
         * @see DataFormatEnum#getValue()
         */
        private Integer messageDataType;
    }
}
